/* imgmirc.dll is a plug-in for the mIRC application
* Copyright (C) 2003-2005 Ivan Zvolsky
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version. 
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library (lesser.txt)
*/
#ifndef _COMMON_STORAGE_
#define _COMMON_STORAGE_

//#include "stdafx.h"

template <class _item_class> class _storage {
private:
	void RemAllItems (void);
protected:
	_item_class * head;
public:
	_storage ();
	~_storage ();
};

template <class _item_class>
_storage<_item_class>::_storage()
{
	head = new _item_class;
	head->next = head;
}

template <class _item_class>
_storage<_item_class>::~_storage()
{
	RemAllItems ();
	delete head;
}

template <class _item_class>
void _storage<_item_class>::RemAllItems (void)
{
	_item_class * temp;
	while (head->next != head)
	{
		temp = head->next;
		head->next = temp->next;
		delete temp;
	}
}

#endif