/* imgmirc.dll is a plug-in for the mIRC application
 * Copyright (C) 2003-2005 Ivan Zvolsky
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version. 
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library (lesser.txt)
 */
#ifndef _CONVERSATION_THREAD_
#define _CONVERSATION_THREAD_

//typedef unsigned long * ULONG_PTR;

DWORD WINAPI Conversator(LPVOID lpParameter);
HDDEDATA CALLBACK DdeCallback(
  UINT uType,         // transaction type
  UINT uFmt,          // clipboard data format
  HCONV hconv,        // handle to the conversation
  HSZ hsz1,           // handle to a string
  HSZ hsz2,           // handle to a string
  HDDEDATA hdata,     // handle to a global memory object
  ULONG_PTR dwData1,  // transaction-specific data
  ULONG_PTR dwData2   // transaction-specific data
);

#define verb_conv_echo if (_VERBOSE_) conv_echo
 
void conv_command (HCONV hConv,char * data);
HDDEDATA conv_evaluate (HCONV hConv,char * data,BOOL keep);
void evaluate (char * data);
void conv_echo (const char * str, int color = 1);
void conv_echo (int color, const char * format_string, ...);
void conv_command (const char * format_string, ...);

#endif
