/* imgmirc.dll is a plug-in for the mIRC application
* Copyright (C) 2003-2005 Ivan Zvolsky
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version. 
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library (lesser.txt)
*/
#include "stdafx.h"
#include "msgs_hook.h"
#include "convthread.h"

HHOOK hhk_msgs = NULL;

LRESULT CALLBACK GetMsgProc(
							int nCode,     // hook code
							WPARAM wParam, // current-process flag
							LPARAM lParam  // message data
							)

{
	MSG * p_msg = (MSG *) lParam;
	static BOOL flag = false;

	switch (p_msg->message)
	{
	case WM_SYSCOMMAND:
		if (p_msg->wParam == SC_CLOSE && p_msg->hwnd==mircWnd && !flag)
		{
			flag = true;
			conv_command (hCmdConv,"/im_allquit");
		}
		return CallNextHookEx(hhk_msgs, nCode, wParam, lParam);

	case WM_NCLBUTTONDOWN:
		if (p_msg->wParam == HTCLOSE && p_msg->hwnd==mircWnd && !flag) 
		{
			flag = true;
			conv_command (hCmdConv,"/im_allquit");
		}
		return CallNextHookEx(hhk_msgs, nCode, wParam, lParam);

	default:return CallNextHookEx(hhk_msgs, nCode, wParam, lParam);
	}

}