/* imgmirc.dll is a plug-in for the mIRC application
* Copyright (C) 2003-2005 Ivan Zvolsky
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version. 
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library (lesser.txt)
*/
#ifndef _REPLSTORAGE_
#define _REPLSTORAGE_

#include "imgstorage.h"
#include "highlights.h"

class _repl_item
{
public:
	_image_item * img;
	_hl_item * hl;
	RECT rect_image;

public:
	_repl_item ():img(NULL),hl(NULL) {}
	_repl_item (LPCTSTR, LPCTSTR, RECT *);
	~_repl_item ();
};

void LoadReplacementsList (void);

extern std::vector<_repl_item *> repl_list;
extern std::vector<RECT> text_list; 

#endif